#
# spec file for package gpac
#
# Copyright (c) 2012 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

%define soname		3

Name:           gpac
Version:        0.5.0.svn5178
Release:        5.7
License:        LGPL-2.1+
Summary:        A multimedia framework covering MPEG-4, VRML/X3D and SVG
Group:          Productivity/Multimedia/Video/Editors and Convertors
Url:            http://gpac.sourceforge.net
Source:		%{name}-%{version}.tar.bz2
Source90:       %{name}-rpmlintrc
#PATCH-FIX-openSUSE i@marguerite.su - openSUSE only fix for sf#3574796
Patch0:         gpac-0.5.0-smjs_call_prop_stub.patch
#PATCH-FIX-UPSTREAM i@marguerite.su - enable osmozilla and osmo4_wx
Patch1:		gpac-0.5.0-enable_V4Studio.patch
#PATCH-FIX-UPSTREAM i@marguerite.su - fix SVGGen ldflags
Patch2:		gpac-0.5.0-SVGGen_abuild.patch
#PATCH-FIX-UPSTREAM wengxuetian@gmail.com - fix E: 64bit-portability-issue
Patch3:		gpac-0.5.0-64bit-portability.patch
#PATCH-FIX-OPENSUSE marguerite@opensuse.org - libpng include dir fix
Patch4:		gpac-0.5.0-libpng-version-detection.patch
#PATCH-FIX-UPSTREAM marguerite@opensuse.org - use system amrnb/amrwb
Patch5:		gpac-0.5.0-system-amr.patch
#PATCH-FIX-UPSTREAM marguerite@opensuse.org - no gpac.pc in devel package
Patch6:		gpac-0.5.0-no-pc.patch
#PATCH-FIX-UPSTREAM marguerite@opensuse.org - too many arguments for JS_GetParent
Patch7:		gpac-0.5.0-js_getparent.patch
#PATCH-FIX-UPSTREAM marguerite@opensuse.org - I:Statement is overflowing a buffer
Patch8:		gpac-0.5.0-bufferoverflow.patch
#PATCH-FIX-UPSTREAM marguerite@opensuse.org - fix gf_isom_set_pixel_aspect_ratio
# not available to the public
Patch9:		gpac-0.5.0-x264-export.patch
BuildRequires:  DirectFB-devel
BuildRequires:  ImageMagick
BuildRequires:  Mesa-devel
BuildRequires:  alsa-devel
BuildRequires:  dos2unix
BuildRequires:  doxygen
BuildRequires:	fdupes
BuildRequires:  freeglut-devel
BuildRequires:  freetype2-devel
BuildRequires:	graphviz
BuildRequires:  gcc-c++
%if 0%{?suse_version} >= 1140
BuildRequires:  libSDL-devel
%else
BuildRequires:  SDL-devel
%endif
BuildRequires:  liba52-devel
BuildRequires:  libfaad-devel
BuildRequires:  libffmpeg-devel
# fix for evergreen 11
%if 0%{?suse_version} == 1110
BuildRequires:  libidl
%endif
BuildRequires:  libjpeg-devel
BuildRequires:  libmad-devel
BuildRequires:  libogg-devel
BuildRequires:  libpng-devel
BuildRequires:  libpulse-devel
BuildRequires:  librsvg-devel >= 2.5.0
BuildRequires:  libtheora-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libxvidcore-devel
%if 0%{?suse_version} == 1140
BuildRequires:  mozilla-js192
%endif
%if 0%{?suse_version} > 1140
BuildRequires:  js-devel
%endif
%if 0%{?suse_version} <= 1140
%if ! 0%{?sles_version}
BuildRequires:  mozilla-xulrunner192-devel
%endif
%else
BuildRequires:  xulrunner-devel
%endif
BuildRequires:  libopenssl-devel
%if 0%{?suse_version} > 1140
BuildRequires:  pkgconfig(libopenjpeg)
%endif
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  unzip
BuildRequires:  update-desktop-files
%if 0%{?suse_version} >= 1140
BuildRequires:  wxWidgets-wxcontainer-devel
%else
BuildRequires:  wxGTK-devel
%endif
BuildRequires:  zlib-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
GPAC is a multimedia framework for MPEG-4, VRML/X3D and SVG/SMIL.

GPAC is built upon an implementation of the MPEG-4 Systems standard
(ISO/IEC 14496-1) developed from scratch in C.

The main development goal is to provide a clean (a.k.a. readable by
as many people as possible), small and flexible alternative to the
MPEG-4 Systems reference software (known as IM1 and distributed in
ISO/IEC 14496-5).

The second development goal is to achieve integration of recent
multimedia standards (SVG/SMIL, VRML, X3D, SWF, etc) into a single
framework. This stage is still under drafting but GPAC already
supports most of VRML97, some X3D as well as very simple SVG.

GPAC already features 2D and 3D multimedia playback, MPEG-4 Systems
encoders/multiplexers and publishing tools for content distribution.

GPAC is licensed under the GNU Lesser General Public License.

The current GPAC release (0.4.5) already covers a very large part of
the MPEG-4 standard, and features what can probably be seen as the
most advanced and robust 2D MPEG-4 Player available worldwide, as
well as a decent 3D MPEG-4/VRML player.

Author:         Jean Le Feuvre <jeanlf at users.sourceforge.net>

%package -n libgpac%{soname}
Summary:        Shared libraries for gpac
Group:          System/Libraries

%description -n libgpac%{soname}
Shared libraries for package gpac.

%package -n libgpac-devel
Summary:        Development files for gpac
Group:          Development/Languages/C and C++
Requires:       libgpac%{soname} = %{version}
# old name
Provides:       gpac-devel = %{version}
Obsoletes:      gpac-devel < %{version}

%description -n libgpac-devel
Development files for gpac.

Author:         Jean Le Feuvre <jeanlf@users.sourceforge.net>

%package -n Osmo4
Summary:        MPEG-4 Media player based on gpac
Group:          Productivity/Multimedia/Video/Players
Requires:       %{name} = %{version}

%description -n Osmo4
Osmo4 is an MPEG-4 player with the following features:
* MPEG-4 Systems player:
* Optimized 2D graphics renderer compliant with the Complete2D Scene
  Graph and Graphics profiles.
* Video and audio presentation achieved through plugins
* Multimedia player features:
* Timeline controls: play, pause, step.
* Graphics features: antialising, zoom and pan, scalable resizing
  of rendering area
* Support for Advanced Text and Graphics extension of MPEG-4 Systems
* Frame export to JPG, PNG, BMP.

Osmo4 enables the use of MPEG-4 Systems in a vast aplication domain,
among which:
* downloaded or streamed cartoons
* synchronized, interactive mixes of graphics, text, video and audio
* applications benefiting from MPEG-7 and MPEG-21 advances: meta-data,
  encryption, watermarking, rights management

%if ! 0%{?sles_version}
%package browser-plugin
Summary:        Osmozilla is a GPAC plugin for Mozilla-based browsers
Group:          Productivity/Networking/Web/Utilities
Requires:       %{name} = %{version}

%description browser-plugin
Osmozilla is a GPAC plugin for Mozilla-based browsers.
%endif

%prep
%setup -q
%if 0%{?suse_version} >= 1210
%patch0 -p1
%endif
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%if 0%{?suse_version} > 1140
%patch7 -p1
%endif
%patch8 -p1
%patch9 -p1

# Fix encoding warnings
cp -p Changelog Changelog.origine
iconv -f ISO-8859-1 -t UTF8 Changelog.origine > Changelog
touch -r Changelog.origine Changelog
rm -rf Changelog.origine

cp -p doc/ipmpx_syntax.bt doc/ipmpx_syntax.bt.origine
iconv -f ISO-8859-1 -t UTF8 doc/ipmpx_syntax.bt.origine > doc/ipmpx_syntax.bt
touch -r doc/ipmpx_syntax.bt.origine doc/ipmpx_syntax.bt
rm -rf doc/ipmpx_syntax.bt.origine

# Generate revision.h
echo '#define GPAC_SVN_REVISION "5178"' > ./include/gpac/revision.h

sed -i~ '1 {s@^.*$@/*@}' src/utils/xml_parser.c
%build
# regenerate plugin interface from IDL (see applications/osmozilla/readme.txt)
%if 0%{?suse_version} > 1140
pushd applications/osmozilla
    chmod 666 nsIOsmozilla.xpt_linux; rm nsIOsmozilla.xpt_linux
    chmod 666 nsIOsmozilla.h
    chmod 666 nsIOsmozilla.idl

    %define _IDL_DIR `pkg-config --variable=idldir libxul`
    %define _SDK_DIR `pkg-config --variable=sdkdir libxul`

    %{_SDK_DIR}/sdk/bin/header.py \
   	-I%{_IDL_DIR} \
        -o nsIOsmozilla.h \
   	nsIOsmozilla.idl
        %{_SDK_DIR}/sdk/bin/typelib.py \
   	-I%{_IDL_DIR} \
       -o nsIOsmozilla.xpt \
   	nsIOsmozilla.idl

    cp nsIOsmozilla.xpt nsIOsmozilla.xpt_linux
popd
%else
%if ! 0%{?sles_version}
pushd applications/osmozilla
    chmod 666 nsIOsmozilla.xpt_linux; rm nsIOsmozilla.xpt_linux
    chmod 666 nsIOsmozilla.h
    chmod 666 nsIOsmozilla.idl

    %define _IDL_DIR `pkg-config --variable=idldir libxul`
    %define _INC_DIR `pkg-config --variable=includedir libxul`
    %define _LIB_DIR `pkg-config --variable=libdir libxul`

    %{_LIB_DIR}/xpidl \
        -m header \
        -I%{_IDL_DIR} \
        -I%{_INC_DIR}/xpcom/idl \
        nsIOsmozilla.idl
    %{_LIB_DIR}/xpidl \
        -m typelib \
        -I%{_IDL_DIR} \
        -I%{_INC_DIR}/xpcom/idl \
        nsIOsmozilla.idl
    %{_LIB_DIR}/xpt_link \
        nposmozilla.xpt nsIOsmozilla.xpt

    cp nsIOsmozilla.xpt nsIOsmozilla.xpt_linux
popd
%endif
%endif

# configure the beast
./configure \
    --prefix=%{_prefix} \
%ifarch x86_64
    --libdir=lib64 \
%endif
    --mandir=%{_mandir} \
%if ! 0%{?sles_version}
    --xulsdk-path=`pkg-config --variable=sdkdir libxul` \
%endif
    --extra-cflags="%{optflags} -D_FILE_OFFSET_BITS=64 -D_LARGE_FILES -D_LARGEFILE_SOURCE=1 -DXP_UNIX -fPIC" 

# make the beast (NO parallel build possible ...)
# fix I: File is compiled without RPM_OPT_FLAGS gpac doesn't respect any flags at all
make all CFLAG="%{optflags}"
make sggen 
make -C applications/generators/SVG
make -C applications/udptsseg

# create dev-docs
pushd doc
    doxygen -u
    doxygen
popd

%install
%make_install 

# header files
make install-lib \
    DESTDIR=%{buildroot}

# browser-plugin
%if ! 0%{?sles_version}
install -dm 755 %{buildroot}%{_libdir}/browser-plugins
install -m 755 bin/gcc/nposmozilla.so \
    %{buildroot}%{_libdir}/browser-plugins
install -m 755 bin/gcc/nposmozilla.xpt \
    %{buildroot}%{_libdir}/browser-plugins
%endif

# generated sggen binaries
for i in MPEG4 SVG X3D; do
    install -m 755 applications/generators/$i/${i}Gen \
    	%{buildroot}%{_bindir}
done
install -m 755 bin/gcc/mp4* \
    %{buildroot}%{_bindir}

# udptsseg
install -m 755 bin/gcc/udptsseg \
    %{buildroot}%{_bindir}

# Osmo4
install -m 755 bin/gcc/Osmo4 \
    %{buildroot}%{_bindir}

# icon
install -dm 755 %{buildroot}%{_datadir}/pixmaps
convert -size 48x48 applications/osmo4_wx/osmo4.xpm \
    Osmo4.png
install -m 644 Osmo4.png \
    %{buildroot}%{_datadir}/pixmaps

# menu-entry
install -dm 755 %{buildroot}%{_datadir}/applications
cat > Osmo4.desktop << EOF
[Desktop Entry]
Comment=MPEG-4 Media player based on gpac
Name=Osmo4
GenericName=MPEG-4 Media player based on gpac
Type=Application
Exec=Osmo4
Icon=Osmo4
Terminal=false
EOF
%suse_update_desktop_file -i Osmo4 AudioVideo Player

# static lib
rm -rf %{buildroot}%{_libdir}/*.a

%fdupes %{buildroot}

%post -n libgpac%{soname} -p /sbin/ldconfig

%postun -n libgpac%{soname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS BUGS Changelog COPYING README TODO
%doc doc/configuration.html
%{_bindir}/DashCast
%{_bindir}/MP4Box
%{_bindir}/MP4Client
%{_bindir}/MPEG4Gen
%{_bindir}/X3DGen
%{_bindir}/SVGGen
%{_bindir}/mp42ts
%{_bindir}/udptsseg
%{_libdir}/%{name}/
%{_datadir}/%{name}/
%{_mandir}/man1/*

%files -n libgpac%{soname}
%defattr(-,root,root)
%{_libdir}/*.so.%{soname}
%{_libdir}/*.so.%{soname}.*

%files -n libgpac-devel
%defattr(-,root,root)
%doc doc/CODING_STYLE doc/ipmpx_syntax.bt
%{_includedir}/%{name}/
%{_libdir}/*.so
%{_libdir}/pkgconfig/%{name}.pc

%files -n Osmo4
%defattr(-,root,root)
%{_bindir}/Osmo4
%{_datadir}/pixmaps/Osmo4.png
%{_datadir}/applications/Osmo4.desktop

%if ! 0%{?sles_version}
%files browser-plugin
%defattr(-,root,root)
%{_libdir}/browser-plugins/nposmozilla.*
%endif

%changelog
* Mon Jul 14 2014 olaf@aepfle.de
- fix compile of src/utils/xml_parser.c in sle11
* Fri May 30 2014 olaf@aepfle.de
- BuildRequire libopenjpeg only in 12.1 or later
* Sat Mar 22 2014 i@margueirte.su
- update 0.5.0.svn5178
- added patch: gpac-0.5.0-js_getparent.patch
  * fix "too many arguments for JS_GetParent" error after
    forcing USE_FFDEV_18
- added patch: gpac-0.5.0-bufferoverflow.patch
  * fix I: Statement is overflowing a buffer error in OBS.
* Fri Jul 26 2013 i@margueirte.su
- better detect libpng version
- fix no gpac.pc in -devel package
- export functions needed by x264
* Sun Jul 21 2013 i@margueirte.su
- update 0.5.0.svn4668
- revert "wo_application" changes, it fails the whole build
- remove patch: gpac-0.5.0-x264-export.patch, upstreamed
- add libpng15/libpng14 patches.
- use system libamrwb/libamrnb.
* Fri Feb  8 2013 obs@botter.cc
- svn4296 - includes fixes for compilation with Firefox 18
- disable while compiling with xulrunner 17.0.2
  * subpackage Osmo4
  * browser-client
  * MP4client in main package
* Mon Nov  5 2012 i@margueirte.su
- fix sles and < 1140 builds.
* Thu Nov  1 2012 i@margueirte.su
- fix Tumbleweed builds.
- adjust enable_V4Studio.patch.
  * do not use static lib for linking.
* Thu Oct  4 2012 i@marguerite.su
- update to 0.5.0
  * MPEG-DASH and HLS support (players and MP4Box)
  * MPEG-U Widgets and UPnP support in the player
  * Stereo and multiview display support
  * Better AVC and SVC support including OpenSVC decoder integration
  * More live tools: RTP, MPEG-TS, T-DMB support, scene encoders (BIFS and RME/DIMS)
  * iOS and Android support
  * and many other good things
- svn4192 fixes sf#3574796:
  * Osmozilla: change switch_up type from int to long, since xulrunner 15 doesn't support int type directly.
  * change bogus uuid in Osmozilla.
  * fix mozjs15 depreciated JS_ConstructObject to JS_New.
- enable_V4Studio patch
  * upstream masked Osmo4_wx and osmozilla. I enabled them and fix linker errors.
- smjs_call_prop_stub.patch
  * fix openSUSE xulrunner version.
- SVGGen_abuild.patch
  * fix applications/generators/SVG linker errors.
- 64bit-portability.patch
  * fix OBS errors and warnings.
- enable build udptsseg, a HTTP streaming tool.
- spec clean.
  * remove _with_amr. we're already in PMBS.
  * correct BuildRequires package names and remove unneeded Requires.
  * remove dos2unix fixes
  * remove 64bit adjustments. we use upstream options.
  * remove libpng-1.4.0 fix. no longer need.
  * remove SONAME. upstream did that.
  * remove openjpeg fix.
  * remove unneeded configure options.
  * remove < 1140 conditionals.
  * use new ffmpeg. upstream code change.
  * add IDL regeneration for newer xulrunner.
  * enable osmozilla for all openSUSE versions. although few need it.
- TODO: enable hbbtvplayer builds.
* Fri Dec 16 2011 pascal.bleser@opensuse.org
- fix build on recent openSUSE versions, failure was introduced by missing OPENJPEG_VERSION
* Mon Jan 11 2010 toni@links2linux.de
- fixed buildroot usage:
  Error: no modules found in /usr/src/packages/BUILDROOT/gpac-0.4.5-0.pm.5.17.x86_64/usr/lib64/gpac
* Tue Dec  2 2008 toni@links2linux.de
- update to 0.4.5
- added libgpac0 subpackage
- added librsvg2(-devel) to BuildRequires
- install also the *Gen applications
* Wed Sep 24 2008 toni@links2linux.de
- rebuild with new libffmpeg0-devel, libmad-devel, libfaad2-devel,
  libxvidcore-devel packages
- patched for new ffmpeg-API
  (bits_per_sample ==> bits_per_coded_sample, CODEC_ID_MP3LAME ==> CODEC_ID_MP3)
* Fri Dec 21 2007 toni@links2linux.de
- rebuild with new ffmpeg package
* Sun Jul  1 2007 toni@links2linux.de
- use --extra-flags, as CPFLAGS/OPTFLAGS are not recognized in configure
  thx to Richard Sotke <tee@teeforum.com>
* Fri Jun  1 2007 toni@links2linux.de
- merged in 64bit patch/spec-file and corrected BuildRequires
- added rebuild of idl
- should now build on all SuSE-10.x
* Thu May 31 2007 toni@links2linux.de
- update to 0.4.4
* Sat Apr 21 2007 toni@links2linux.de
- update to 0.4.3-cvs20070420
* Fri Mar  9 2007 toni@links2linux.de
- update to 0.4.3-cvs20070309
* Sun Jan 28 2007 toni@links2linux.de
- update to 0.4.3-cvs20070126
* Tue Jan 16 2007 toni@links2linux.de
- update to 0.4.3-cvs20070115
* Wed Dec 13 2006 toni@links2linux.de
- update to 0.4.3-cvs20061213
* Sat Dec  9 2006 toni@links2linux.de
- rebuild with browser-plugin and enabled --enable-amr
* Fri Dec  8 2006 toni@links2linux.de
- initial build 0.4.3-cvs20061114
